#ifndef __AMIR_FUNDAMENTAL_TYPES_H__

#define __AMIR_FUNDAMENTAL_TYPES_H__

/* تعریف مقدار نادرست. */
#ifndef FALSE
#define FALSE 0
#endif

/* تعریف مقدار درست. */
#ifndef TRUE
#define TRUE (!FALSE)
#endif

/* تعریف مقدار پوچ. */
#if !defined(NULL)
#if defined(__cplusplus)
#define NULL 0
#else
#define NULL ((void*)0)
#endif
#endif

#ifdef  __cplusplus
extern "C" {
#endif

/*
 * نوع داده‌ای پوچ.
 */
typedef void amr_void;

/*
 * نوع داده‌ای منطقی.
 */
typedef unsigned char amr_bool;

/*
 * نوع داده‌ای حسابی 8 بیتی.
 */
typedef unsigned char amr_byte;

/*
 * نوع داده‌ای صحیح 8 بیتی.
 */
typedef signed char amr_sbyte;

/*
 * نوع داده‌ای حسابی 16 بیتی.
 */
typedef unsigned short int amr_ushort;

/*
 * نوع داده‌ای صحیح 16 بیتی.
 */
typedef signed short int amr_short;

/*
 * نوع داده‌ای حسابی 32 بیتی.
 */
typedef unsigned long int amr_uint;

/*
 * نوع داده‌ای صحیح 32 بیتی.
 */
typedef signed long int amr_int;

/*
 * نوع داده‌ای ممیز شناور.
 */
typedef float amr_single;

/*
 * نوع داده‌ای ممیز شناور با دقت مضاعف.
 */
typedef double amr_double;

/*
 * نوع داده‌ای نویسه.
 */
typedef char amr_char;

/*
 * نوع داده‌ای رشته.
 */
typedef char* amr_string;

/*
 * نوع داده‌ای اشاره‌گر.
 */
typedef void* amr_pointer;

#ifdef  __cplusplus
}
#endif

#endif
